VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1995
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2550
   LinkTopic       =   "Form1"
   ScaleHeight     =   1995
   ScaleWidth      =   2550
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGetCardType 
      Caption         =   "Get Card Type"
      Default         =   -1  'True
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   1080
      Width           =   975
   End
   Begin VB.ComboBox cboCardType 
      Height          =   315
      Left            =   240
      Sorted          =   -1  'True
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   600
      Width           =   2055
   End
   Begin VB.TextBox txtCardNumber 
      Height          =   285
      Left            =   240
      TabIndex        =   1
      Text            =   "9999 9999 9999 9999"
      Top             =   240
      Width           =   2055
   End
   Begin VB.CommandButton cmdValidate 
      Caption         =   "Validate"
      Height          =   495
      Left            =   1320
      TabIndex        =   0
      Top             =   1080
      Width           =   975
   End
   Begin VB.Label lblResult 
      Alignment       =   2  'Center
      Height          =   255
      Left            =   840
      TabIndex        =   2
      Top             =   1680
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type CardInfoType
    CardName As String
    CardPrefix As String
    CardLength As Integer
    PrefixLength As Integer
End Type

Private m_NumCardTypes As Integer
Private m_CardInfo() As CardInfoType

' Add a card to the card prefix and name collections.
Private Sub AddCardType(ByVal card_prefix As String, ByVal card_name As String, ByVal card_length As Integer)
    m_NumCardTypes = m_NumCardTypes + 1
    ReDim Preserve m_CardInfo(1 To m_NumCardTypes)

    With m_CardInfo(m_NumCardTypes)
        .CardName = card_name
        .CardPrefix = card_prefix
        .CardLength = card_length
        .PrefixLength = Len(card_prefix)
    End With
End Sub
' Initialize the list of card prefixes and names.
' The values must be added in order so no value is
' a prefix of an earlier value. Here we do this by
' putting the longest values first.
Private Sub InitializeCardTypes()
    AddCardType "6011", "Discover", 16
    AddCardType "2014", "EnRoute", 15
    AddCardType "2149", "EnRoute", 15
    AddCardType "2131", "JCB", 15
    AddCardType "1800", "JCB", 15
    AddCardType "300", "Diners Club", 14
    AddCardType "301", "Diners Club", 14
    AddCardType "302", "Diners Club", 14
    AddCardType "303", "Diners Club", 14
    AddCardType "304", "Diners Club", 14
    AddCardType "305", "Diners Club", 14
    AddCardType "36", "Diners Club", 14
    AddCardType "38", "Carte Blanche", 14
    AddCardType "34", "American Express", 15
    AddCardType "37", "American Express", 15
    AddCardType "51", "Master Card", 16
    AddCardType "52", "Master Card", 16
    AddCardType "53", "Master Card", 16
    AddCardType "54", "Master Card", 16
    AddCardType "55", "Master Card", 16
    AddCardType "3", "JCB", 16
    AddCardType "4", "Visa", 13
    AddCardType "4", "Visa", 16
End Sub
' Return True if the credit card number
' makes sense.
Public Function ValidCard(ByVal card_number As String, ByVal card_type As String) As Boolean
Dim num_digits As Integer
Dim ch As String
Dim i As Integer
Dim odd_digit As Boolean
Dim doubled_digit As String
Dim checksum As Integer

    ' Assume the validation will fail.
    ValidCard = False

    ' Make sure we have a card type.
    If Len(card_type) = 0 Then Exit Function

    ' Remove any spaces.
    card_number = Replace(card_number, " ", "")

    ' Make sure we have 16 digits.
    If Len(card_number) <> 16 Then Exit Function

    ' Examine the digits.
    odd_digit = False
    For i = Len(card_number) To 1 Step -1
        ch = Mid$(card_number, i, 1)
        If ch < "0" Or ch > "9" Then
            ' Not a digit. Validation fails.
            Exit Function
        Else
            ' Process this digit.
            odd_digit = Not odd_digit
            If odd_digit Then
                ' Odd digit. Add it to the checksum
                checksum = checksum + CInt(ch)
            Else
                ' Even digit. Double it and add the
                ' digits in the result to the checksum
                doubled_digit = Format$(2 * CInt(ch))
                checksum = checksum + CInt(Left$(doubled_digit, 1))
                If Len(doubled_digit) = 2 Then checksum = checksum + CInt(Mid$(doubled_digit, 2, 1))
            End If
        End If
    Next i

    ' Check the checksum.
    If (checksum Mod 10) <> 0 Then Exit Function

    ' Check the card type.
    ValidCard = (card_type = CardType(card_number))
End Function
' Return the credit card's type. Return ""
' if the type is unknown. This routine assumes
' the card number contains only digits.
Function CardType(ByVal card_number As String) As String
Dim i As Integer

    ' Search the card types for this prefix.
    For i = 1 To UBound(m_CardInfo)
        With m_CardInfo(i)
            If (.CardLength = Len(card_number)) And _
               (.CardPrefix = Left$(card_number, .PrefixLength)) _
            Then
                CardType = .CardName
                Exit Function
            End If
        End With
    Next i

    ' We did not find a matching card type.
    CardType = ""
    Exit Function
End Function

Private Sub cmdGetCardType_Click()
Dim card_type As String
Dim i As Integer

    card_type = CardType(txtCardNumber.Text)
    cboCardType.ListIndex = -1

    For i = 0 To cboCardType.ListCount - 1
        If cboCardType.List(i) = card_type Then
            cboCardType.ListIndex = i
            Exit For
        End If
    Next i
End Sub

Private Sub cmdValidate_Click()
    If ValidCard(txtCardNumber.Text, cboCardType.Text) Then
        lblResult.Caption = "Valid"
    Else
        lblResult.Caption = "Not valid"
    End If
End Sub


Private Sub Form_Load()
Dim i As Integer
Dim j As Integer

    ' Initialize the card information.
    InitializeCardTypes

    ' Fill the ComboBox with card names.
    For i = 1 To UBound(m_CardInfo)
        ' See if this value is already here.
        For j = 0 To cboCardType.ListCount - 1
            If m_CardInfo(i).CardName = cboCardType.List(j) Then Exit For
        Next j

        If j >= cboCardType.ListCount Then
            cboCardType.AddItem m_CardInfo(i).CardName
        End If
    Next i
End Sub

Private Sub txtCardNumber_Change()
    lblResult.Caption = ""
End Sub
